From bc8e0276632c0b5512e5579653bf5587f22dbcc4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 25 2020 23:58:45 +0000
Subject: [PATCH 1547/2232] Merge pull request #511 from dtolnay/fielderr


Allow simultaneous diagnostics on multiple fields of a struct
---

diff --git a/syntax/parse.rs b/syntax/parse.rs
index 15ee4f2..18809b5 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -89,16 +89,18 @@ fn parse_struct(cx: &mut Errors, item: ItemStruct, namespace: &Namespace) -> Res
         }
     };
 
-    let fields = named_fields
-        .named
-        .into_iter()
-        .map(|field| {
-            Ok(Var {
-                ident: field.ident.unwrap(),
-                ty: parse_type(&field.ty)?,
-            })
-        })
-        .collect::<Result<_>>()?;
+    let mut fields = Vec::new();
+    for field in named_fields.named {
+        let ident = field.ident.unwrap();
+        let ty = match parse_type(&field.ty) {
+            Ok(ty) => ty,
+            Err(err) => {
+                cx.push(err);
+                continue;
+            }
+        };
+        fields.push(Var { ident, ty });
+    }
 
     Ok(Api::Struct(Struct {
         doc,
diff --git a/tests/ui/array_len_expr.rs b/tests/ui/array_len_expr.rs
index fdd9783..1e1a548 100644
--- a/tests/ui/array_len_expr.rs
+++ b/tests/ui/array_len_expr.rs
@@ -1,8 +1,8 @@
 #[cxx::bridge]
 mod ffi {
-    unsafe extern "C++" {
-        fn arraystr() -> [String; "13"];
-        fn arraysub() -> [String; 15 - 1];
+    struct Shared {
+        arraystr: [String; "13"],
+        arraysub: [String; 15 - 1],
     }
 }
 
diff --git a/tests/ui/array_len_expr.stderr b/tests/ui/array_len_expr.stderr
index cb94328..bbd7d11 100644
--- a/tests/ui/array_len_expr.stderr
+++ b/tests/ui/array_len_expr.stderr
@@ -1,11 +1,11 @@
 error: array length must be an integer literal
- --> $DIR/array_len_expr.rs:4:35
+ --> $DIR/array_len_expr.rs:4:28
   |
-4 |         fn arraystr() -> [String; "13"];
-  |                                   ^^^^
+4 |         arraystr: [String; "13"],
+  |                            ^^^^
 
 error: unsupported expression, array length must be an integer literal
- --> $DIR/array_len_expr.rs:5:35
+ --> $DIR/array_len_expr.rs:5:28
   |
-5 |         fn arraysub() -> [String; 15 - 1];
-  |                                   ^^^^^^
+5 |         arraysub: [String; 15 - 1],
+  |                            ^^^^^^

